<?php
class Topcmmchat_Controller_Action_Helper_UpdateChat extends Topcmmchat_Controller_Action_Helper_RequestRemote {

	function save_Local_Settings($request = "", $table) {
		$chatfun = new Topcmmchat_Controller_Action_Helper_ChatFun();
		if (!$request) {
			$error_Info .= "Save Failed";
			return $error_Info;
		}
		$fc_extendserver = "0";
        $fc_servertype = $request['fc_servertype'];
        $client_location = $request['fc_client_loc'];
		if($client_location){
	    	$fc_client_loc = $client_location . (substr($client_location,-1,1) != '/' ? '/' : '');
	    	$serverinfo = $this->getServerHostPortLocal($fc_client_loc);
            
	    	$fc_server_host = !empty($request['fc_server_host']) ? $request['fc_server_host'] : (empty($serverinfo['fc_server_host']) ? $_SERVER['HTTP_HOST'] : $serverinfo['fc_server_host']) ;
	    	$fc_server_host_s = empty($serverinfo['fc_server_host_s']) ? $fc_server_host : $serverinfo['fc_server_host_s'];
	    	$fc_server_host_h = empty($serverinfo['fc_server_host_h']) ? $fc_server_host : $serverinfo['fc_server_host_h'];
            
	    	if(!is_numeric($request['fc_server_port']) || strpos($request['fc_server_port'] ,".")!==false){
	    		$fc_server_port = empty($serverinfo['fc_server_port']) ? ( $fc_servertype ==1 ? '51212' : '51127') : $serverinfo['fc_server_port'] ;
	    	}else{
	    		$fc_server_port = $request['fc_server_port'];
	    	}
	    	if(!is_numeric($request['fc_server_port_h']) || strpos($request['fc_server_port_h'] ,".")!==false){
	    		$fc_server_port_h = empty($serverinfo['fc_server_port_h']) ? ( $fc_servertype == 1 ? '31212' : '35555') : $serverinfo['fc_server_port_h'] ;
	    	}else{
	    		$fc_server_port_h = $request['fc_server_port_h'];
	    	}
	    	$fc_server_port_s = empty($serverinfo['fc_server_port_s']) ? ( $fc_servertype == 1 ? '51213' : '51128') : $serverinfo['fc_server_port_s'] ;
	    	$fc_api_url = 'http://' . $fc_server_host . ':' . $fc_server_port_h . '/';
            
		}else{
		  
			$fc_server_host = $_SERVER['HTTP_HOST'];
            $fc_server_host_h = $fc_server_host;
            $fc_server_host_s = $fc_server_host;
 	    	if($fc_servertype == 1){
	    		$fc_server_port_h = 31212;
	    		$fc_server_port_s = 51213;
	    		$fc_server_port = 51212;
	    	}else{
	    		$fc_server_port_h = 35555;
	    		$fc_server_port_s = 51128;
	    		$fc_server_port = 51127;
	    	}
			$fc_api_url = 'http://' . $fc_server_host . ':' . $fc_server_port_h . '/';
			$fc_client_loc = $fc_api_url;
		}	
        
        $fc_clienttype = ($fc_servertype == 1) ? 0 : $request['fc_clienttype'];
        			
		$fc_client_loc .= (substr($fc_client_loc, 0, 7) == "http://") ? "" : "http://";		
		$c_own_loc = $chatfun->validate_client($fc_client_loc);
		if ($c_own_loc) {
			$error_Info .= "Client Location is configured incorrectly";
			return $error_Info;
		}
		$da = $chatfun->validate_data_api($fc_api_url . 'online.js');
		if ($da) {
			$error_Info .= "Chat Server host or http_port is configured incorrectly";
			return $error_Info;
		}
		$getHost = array (
			'fc_extendserver' => $fc_extendserver,
            'fc_servertype'  => $fc_servertype,
			'fc_server_host' => $fc_server_host,
			'fc_server_port' => $fc_server_port,
            'fc_server_host_s' => $fc_server_host_s,
            'fc_server_port_s' => $fc_server_port_s,
            'fc_server_host_h' => $fc_server_host_h,
			'fc_server_port_h' => $fc_server_port_h,
			'fc_client_loc' => $fc_client_loc,
			'fc_api_url' => $fc_api_url,
            'fc_clienttype' => $fc_clienttype
		);

		$getPublic = $this->getPublic($request);

		$getPost = $getHost + $getPublic;

		$updatechat = $this->UpdateChatSettingTabel($getPost, $table);
		return $updatechat;
	}

	function save_Host_Settings($request = "", $table) {
		$remote = new Topcmmchat_Controller_Action_Helper_RequestRemote();
		$chatfun = new Topcmmchat_Controller_Action_Helper_ChatFun();

		if (!$request) {
			$error_Info .= "Save Failed";
			return $error_Info;
		}
		$fc_extendserver = "1";
		$fc_client_loc = $request['fc_client_loc'] ? ($request['fc_client_loc'] . (substr($request['fc_client_loc'], -1, 1) != '/' ? '/' : '')) : '';
        $serverinfo = $this->getServerHostPortHost($fc_client_loc);

        if($serverinfo){
	    	$fc_server_host = empty($serverinfo['fc_server_host']) ? parse_url($fc_client_loc, PHP_URL_HOST) : $serverinfo['fc_server_host'];
	    	$fc_server_host_s = empty($serverinfo['fc_server_host_s']) ? '' : $serverinfo['fc_server_host_s'];
	    	$fc_server_host_h = empty($serverinfo['fc_server_host_h']) ? '' : $serverinfo['fc_server_host_h'];
	    	$fc_server_port = empty($serverinfo['fc_server_port']) ? '' : $serverinfo['fc_server_port'];
	    	$fc_server_port_h = empty($serverinfo['fc_server_port_h']) ? '' : $serverinfo['fc_server_port_h'];
	    	$fc_server_port_s = empty($serverinfo['fc_server_port_s']) ? '' : $serverinfo['fc_server_port_s'];
	    	$fc_api_url = 'http://' . $fc_server_host . '/';
	    	$fc_group = substr(parse_url($fc_client_loc, PHP_URL_PATH),1,-1);
	    	$c_own_loc = $chatfun->validate_client($fc_client_loc);
	    	$da = $chatfun->validate_data_api($fc_api_url . 'online.js?group=' . $fc_group);
	    	if($c_own_loc || $da){
	    		$error_Info .= "Client Location is configured incorrectly";
	        	return $error_Info;
	    	}
	    }else{
	    	$error_Info .= "Client Location is configured incorrectly";
	        return $error_Info;
	    }
        
        $fc_clienttype = $request['fc_clienttype'];

		$getHost = array (
			'fc_extendserver' => $fc_extendserver,
			'fc_server_host' => $fc_server_host,
			'fc_server_port' => $fc_server_port,
            'fc_server_host_s' => $fc_server_host_s,
            'fc_server_port_s' => $fc_server_port_s,
            'fc_server_host_h' => $fc_server_host_h,
			'fc_server_port_h' => $fc_server_port_h,
			'fc_client_loc' => $fc_client_loc,
			'fc_api_url' => $fc_api_url,
            'fc_clienttype' => $fc_clienttype
		);
        
		//public
		$getPublic = $this->getPublic($request);
		$getPost = $getHost + $getPublic;

		$updatechat = $this->UpdateChatSettingTabel($getPost, $table);
		return $updatechat;
	}

	function save_Free_Settings($request = "", $table) {
		if (!$request) {
			$error_Info .= "Save Failed";
			return $error_Info;

		}
		$fc_extendserver = "2";
		$fc_room = $request['fc_room'] ? $request['fc_room'] :'Lobby';
		//$fc_client = 0;

		$getPost = array (
			'fc_extendserver' => $fc_extendserver,
			'fc_room' => $fc_room
		);

		//public
		$getPublic = $this->getPublic($request);
		$getPost = $getPost + $getPublic;
		$updatechat = $this->UpdateChatSettingTabel($getPost, $table);
		return $updatechat;

	}

	function updateChatSetting($UpPost, $table) {
		switch ($UpPost['fc_extendserver']) {
			case 0 :
				$report_Info = $this->save_Local_Settings($UpPost, $table);
				break;
			case 1 :
				$report_Info = $this->save_Host_Settings($UpPost, $table);
				break;
			default :
				$report_Info = $this->save_Free_Settings($UpPost, $table);
		}
		if (!empty ($report_Info)) {
			return $report_Info;
		}
	}

	function UpdateChatSettingTabel($report_Info, $table) {

		$db = $table->getAdapter();
		$where = $db->quoteInto('id = ?', '1');
		
		$row = $table->fetchRow($where);
		$haschanged = 0;
		foreach($report_Info as $key => $value){
			if($row[$key] != $value){
				$haschanged = 1;
			}
		}
		if($haschanged){
			$rows_affected = $table->update($report_Info, $where);
			if ($rows_affected) {
				$updatechat = "Update success!";
			} else {
				$updatechat = "Update Fail!";
			}
		}else{
			$updatechat = "No Changed!";
		}		
		return $updatechat;
	}

	function getPublic($request) {
		//local
		$fc_room_list = $request['fc_rooms'] ? $request['fc_rooms'] : "0";
		$fc_user_list = $request['fc_users'] ? $request['fc_users'] : "0";
		$fc_fullscreen = $request['fc_fullscreen'];
		if (!is_numeric($request['fc_client_width']) || strpos($request['fc_client_width'], ".") !== false) {
			$fc_client_width = 750;
		} else {
			$fc_client_width = $request['fc_client_width'];
		}
		if (!is_numeric($request['fc_client_height']) || strpos($request['fc_client_height'], ".") !== false) {
			$fc_client_height = 528;
		} else {
			$fc_client_height = $request['fc_client_height'];
		}

		$fc_client_lang = $request['fc_client_lang'] ? $request['fc_client_lang'] : 'auto';
		$fc_client_skin = $request['fc_client_skin'] ? $request['fc_client_skin'] : 'default';

		//localpublic
		$getpublic = array (
			'fc_room_list' => $fc_room_list,
			'fc_user_list' => $fc_user_list,
			'fc_fullscreen' => $fc_fullscreen,
			'fc_client_width' => $fc_client_width,
			'fc_client_height' => $fc_client_height,
			'fc_client_lang' => $fc_client_lang,
			'fc_client_skin' => $fc_client_skin
		);
		return $getpublic;
	}
    
    function getServerHostPortLocal($client_location){
		$content = Topcmmchat_Controller_Action_Helper_RequestRemote::requestRemote($client_location.'htmlchat/config/config.js',1);
		if ($content){
			//server host
			preg_match('/init_host = "([a-zA-Z0-9.]*)";/', $content, $matches);
			if(isset($matches[1])){
				$data['fc_server_host'] = $matches[1];
			}else{
				preg_match('/init_host="([a-zA-Z0-9.]*)";/', $content, $matches);
				if(isset($matches[1])){
					$data['fc_server_host'] = $matches[1];
				}else{
					$data['fc_server_host'] = '';
				}
			}
			//server port
			preg_match('/init_port = ([0-9]*);/', $content, $matches);
			if(isset($matches[1])){
				$data['fc_server_port'] = $matches[1];
			}else{
				$data['fc_server_port'] = '';
			}
			//server host s
			preg_match('/init_host_s = "([a-zA-Z0-9.]*)";/', $content, $matches);
			if(isset($matches[1])){
				$data['fc_server_host_s'] = $matches[1];
			}else{
				preg_match('/init_host_s="([a-zA-Z0-9.]*)";/', $content, $matches);
				if(isset($matches[1])){
					$data['fc_server_host_s'] = $matches[1];
				}else{
					$data['fc_server_host_s'] = '';
				}
			}
			//server port s
			preg_match('/init_port_s = ([0-9]*);/', $content, $matches);
			if(isset($matches[1])){
				$data['fc_server_port_s'] = $matches[1];
			}else{
				$data['fc_server_port_s'] = '';
			}
			//server host h
			preg_match('/init_host_h = "([a-zA-Z0-9.]*)";/', $content, $matches);
			if(isset($matches[1])){
				$data['fc_server_host_h'] = $matches[1];
			}else{
				preg_match('/init_host_h="([a-zA-Z0-9.]*)";/', $content, $matches);
				if(isset($matches[1])){
					$data['fc_server_host_h'] = $matches[1];
				}else{
					$data['fc_server_host_h'] = '';
				}
			}
			//server port h
			preg_match('/init_port_h = ([0-9]*);/', $content, $matches);
			if(isset($matches[1])){
				$data['fc_server_port_h'] = $matches[1];
			}else{
				$data['fc_server_port_h'] = '';
			}
			return $data;
		}else{
			return false;
		}
	}
	
	function getServerHostPortHost($client_location){
		$content = Topcmmchat_Controller_Action_Helper_RequestRemote::requestRemote($client_location,1);
		if ($content){
			//server port
			preg_match('/init_port=([0-9]*)/', $content, $matches);
			if(isset($matches[1])){
				$data['fc_server_port'] = $matches[1];
			}
			//server port s
			preg_match('/init_port_s=([0-9]*)/', $content, $matches);
			if(isset($matches[1])){
				$data['fc_server_port_s'] = $matches[1];
			}
			//server port h
			preg_match('/init_port_h=([0-9]*)/', $content, $matches);
			if(isset($matches[1])){
				$data['fc_server_port_h'] = $matches[1];
			}
			//server host
			preg_match('/init_host=([a-zA-Z0-9.]*)/', $content, $matches);
			if(isset($matches[1])){
				$data['fc_server_host'] = $matches[1];
			}
			//server host s
			preg_match('/init_host_s=([a-zA-Z0-9.]*)&/', $content, $matches);
			if(isset($matches[1])){
				$data['fc_server_host_s'] = $matches[1];
			}
			//server host h
			preg_match('/init_host_h=([a-zA-Z0-9.]*)&/', $content, $matches);
			if(isset($matches[1])){
				$data['fc_server_host_h'] = $matches[1];
			}
			return $data;
		}else{
			return false;
		}
	}    
}
?>